//+------------------------------------------------------------------+
//|                                                TripleB  v4.0.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property version   "1.00"
#property strict
#property indicator_chart_window

//--- input parameters
input int    Min_Leg_Range   =   5;
input int    Min_Run_Range   =  13;
input int    Min_Range_Value =  20;
input int    Max_Range_Value = 400;
input color  BoxColor        =  clrBlue;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
double   MinRangeValue,MaxRangeValue;
int      _sp1,_sp2,_sp3,_sp4,_sp5,_sp6,_sp7,_sp8,_sp9,_sp10,_sp11,_sp12,_sp13,_sp14,_sp15,_sp16,_sp17,_sp18,_sp19,_sp20,_sp21,trade_box_no;
datetime StartPointDate1,StartPointDate2,StartPointDate3,StartPointDate4,StartPointDate5,StartPointDate6,StartPointDate7,StartPointDate8,StartPointDate9,StartPointDate10,StartPointDate11,StartPointDate12,StartPointDate13,StartPointDate14,StartPointDate15,StartPointDate16,StartPointDate17,StartPointDate18,StartPointDate19,StartPointDate20,StartPointDate21;
double   LTBH,LTBL; //--- Last trigger box high, last trigger box low

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping

   MinRangeValue = Min_Range_Value * Point;
   MaxRangeValue = Max_Range_Value * Point;
    
   _sp1  = Min_Leg_Range+MathMax(Min_Leg_Range,Min_Run_Range)+1;
   _sp2  = Min_Leg_Range+1+MathMax(Min_Leg_Range+1,Min_Run_Range)+1;
   _sp3  = Min_Leg_Range+2+MathMax(Min_Leg_Range+2,Min_Run_Range)+1;
   _sp4  = Min_Leg_Range+3+MathMax(Min_Leg_Range+3,Min_Run_Range)+1;
   _sp5  = Min_Leg_Range+4+MathMax(Min_Leg_Range+4,Min_Run_Range)+1;
   _sp6  = Min_Leg_Range+5+MathMax(Min_Leg_Range+5,Min_Run_Range)+1;
   _sp7  = Min_Leg_Range+6+MathMax(Min_Leg_Range+6,Min_Run_Range)+1;
   _sp8  = Min_Leg_Range+7+MathMax(Min_Leg_Range+7,Min_Run_Range)+1;
   _sp9  = Min_Leg_Range+8+MathMax(Min_Leg_Range+8,Min_Run_Range)+1;
   _sp10 = Min_Leg_Range+9+MathMax(Min_Leg_Range+9,Min_Run_Range)+1;
   _sp11 = Min_Leg_Range+10+MathMax(Min_Leg_Range+10,Min_Run_Range)+1;
   _sp12 = Min_Leg_Range+11+MathMax(Min_Leg_Range+11,Min_Run_Range)+1;
   _sp13 = Min_Leg_Range+12+MathMax(Min_Leg_Range+12,Min_Run_Range)+1;
   _sp14 = Min_Leg_Range+13+MathMax(Min_Leg_Range+13,Min_Run_Range)+1;
   _sp15 = Min_Leg_Range+14+MathMax(Min_Leg_Range+14,Min_Run_Range)+1;
   _sp16 = Min_Leg_Range+15+MathMax(Min_Leg_Range+15,Min_Run_Range)+1;
   _sp17 = Min_Leg_Range+16+MathMax(Min_Leg_Range+16,Min_Run_Range)+1;
   _sp18 = Min_Leg_Range+17+MathMax(Min_Leg_Range+17,Min_Run_Range)+1;
   _sp19 = Min_Leg_Range+18+MathMax(Min_Leg_Range+18,Min_Run_Range)+1;
   _sp20 = Min_Leg_Range+19+MathMax(Min_Leg_Range+19,Min_Run_Range)+1;
   _sp21 = Min_Leg_Range+20+MathMax(Min_Leg_Range+20,Min_Run_Range)+1;

   StartPointDate1  = Time[_sp1];
   StartPointDate2  = Time[_sp2];
   StartPointDate3  = Time[_sp3];
   StartPointDate4  = Time[_sp4];
   StartPointDate5  = Time[_sp5];
   StartPointDate6  = Time[_sp6];
   StartPointDate7  = Time[_sp7];
   StartPointDate8  = Time[_sp8];
   StartPointDate9  = Time[_sp9];
   StartPointDate10 = Time[_sp10];
   StartPointDate11 = Time[_sp11];
   StartPointDate12 = Time[_sp12];
   StartPointDate13 = Time[_sp13];
   StartPointDate14 = Time[_sp14];
   StartPointDate15 = Time[_sp15];
   StartPointDate16 = Time[_sp16];
   StartPointDate17 = Time[_sp17];
   StartPointDate18 = Time[_sp18];
   StartPointDate19 = Time[_sp19];
   StartPointDate20 = Time[_sp20];
   StartPointDate21 = Time[_sp21];
   
   trade_box_no = 1;

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
datetime initTime;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   if(Time[0]!=initTime)
     {
      initTime = Time[0];     
     
      _sp1     = iBarShift(NULL,0,StartPointDate1);
      _sp2     = iBarShift(NULL,0,StartPointDate2);
      _sp3     = iBarShift(NULL,0,StartPointDate3);
      _sp4     = iBarShift(NULL,0,StartPointDate4);
      _sp5     = iBarShift(NULL,0,StartPointDate5);
      _sp6     = iBarShift(NULL,0,StartPointDate6);
      _sp7     = iBarShift(NULL,0,StartPointDate7);
      _sp8     = iBarShift(NULL,0,StartPointDate8);
      _sp9     = iBarShift(NULL,0,StartPointDate9);
      _sp10    = iBarShift(NULL,0,StartPointDate10);
      _sp11    = iBarShift(NULL,0,StartPointDate11);
      _sp12    = iBarShift(NULL,0,StartPointDate12);
      _sp13    = iBarShift(NULL,0,StartPointDate13);
      _sp14    = iBarShift(NULL,0,StartPointDate14);
      _sp15    = iBarShift(NULL,0,StartPointDate15);
      _sp16    = iBarShift(NULL,0,StartPointDate16);
      _sp17    = iBarShift(NULL,0,StartPointDate17);
      _sp18    = iBarShift(NULL,0,StartPointDate18);
      _sp19    = iBarShift(NULL,0,StartPointDate19);
      _sp20    = iBarShift(NULL,0,StartPointDate20);
      _sp21    = iBarShift(NULL,0,StartPointDate21);

      if(_sp1>Min_Leg_Range+MathMax(Min_Leg_Range,Min_Run_Range))
        {
         for(int i=_sp1; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate1=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range,Min_Run_Range))
             {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range-1],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range-1],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }
      if(_sp2>Min_Leg_Range+1+MathMax(Min_Leg_Range+1,Min_Run_Range))
        {
         for(int i=_sp2; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+1,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+1,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate2=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+1,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }

      if(_sp3> Min_Leg_Range+2+MathMax(Min_Leg_Range+2,Min_Run_Range))
        {
         for(int i=_sp3; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+2,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+2,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate3=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+2,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+1],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+1],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }
        
      if(_sp4> Min_Leg_Range+3+MathMax(Min_Leg_Range+3,Min_Run_Range))
        {
         for(int i=_sp4; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+3,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+3,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate4=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+3,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+2],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+2],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }

      if(_sp5> Min_Leg_Range+4+MathMax(Min_Leg_Range+4,Min_Run_Range))
        {
         for(int i=_sp5; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+4,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+4,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate5=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+4,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+3],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+3],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }
        
      if(_sp6> Min_Leg_Range+5+MathMax(Min_Leg_Range+5,Min_Run_Range))
        {
         for(int i=_sp6; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+5,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+5,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate6=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+5,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+4],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+4],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }

      if(_sp7> Min_Leg_Range+6+MathMax(Min_Leg_Range+6,Min_Run_Range))
        {
         for(int i=_sp7; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+6,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+6,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate7=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+6,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+5],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+5],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }
        
      if(_sp8>Min_Leg_Range+7+MathMax(Min_Leg_Range+7,Min_Run_Range))
        {
         for(int i=_sp8; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+7,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+7,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate8=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+7,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+6],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+6],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }

      if(_sp9>Min_Leg_Range+8+MathMax(Min_Leg_Range+8,Min_Run_Range))
        {
         for(int i=_sp9; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+8,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+8,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate9=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+8,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+7],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+7],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }
        
      if(_sp10>Min_Leg_Range+9+MathMax(Min_Leg_Range+9,Min_Run_Range))
        {
         for(int i=_sp10; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+9,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+9,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate10=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+9,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+8],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+8],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }

      if(_sp11>Min_Leg_Range+10+MathMax(Min_Leg_Range+10,Min_Run_Range))
        {
         for(int i=_sp11; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+10,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+10,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate11=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
              }

            if(valid && bc>=MathMax(Min_Leg_Range+10,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+9],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+9],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }
        
      if(_sp12>Min_Leg_Range+11+MathMax(Min_Leg_Range+11,Min_Run_Range))
        {
         for(int i=_sp12; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+11,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+11,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate12=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+11,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+10],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+10],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }

      if(_sp13>Min_Leg_Range+12+MathMax(Min_Leg_Range+12,Min_Run_Range))
        {
         for(int i=_sp13; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+12,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+12,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate13=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
              }

            if(valid && bc>=MathMax(Min_Leg_Range+12,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+11],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+11],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }
        
      if(_sp14> Min_Leg_Range+13+MathMax(Min_Leg_Range+13,Min_Run_Range))
        {
         for(int i=_sp14; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+13,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+13,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate6=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+13,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+12],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+12],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }

      if(_sp15> Min_Leg_Range+14+MathMax(Min_Leg_Range+14,Min_Run_Range))
        {
         for(int i=_sp15; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+14,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+14,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate7=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+14,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+13],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+13],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }
        
      if(_sp16>Min_Leg_Range+15+MathMax(Min_Leg_Range+15,Min_Run_Range))
        {
         for(int i=_sp16; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+15,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+15,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate8=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+15,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+14],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+14],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }

      if(_sp17>Min_Leg_Range+16+MathMax(Min_Leg_Range+16,Min_Run_Range))
        {
         for(int i=_sp17; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+16,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+16,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate9=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+16,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+15],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+15],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }
        
      if(_sp18>Min_Leg_Range+17+MathMax(Min_Leg_Range+17,Min_Run_Range))
        {
         for(int i=_sp18; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+17,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+17,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate10=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+17,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+16],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+16],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }

      if(_sp19>Min_Leg_Range+18+MathMax(Min_Leg_Range+18,Min_Run_Range))
        {
         for(int i=_sp19; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+18,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+18,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate11=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
              }

            if(valid && bc>=MathMax(Min_Leg_Range+18,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+17],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+17],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }
        
      if(_sp20>Min_Leg_Range+19+MathMax(Min_Leg_Range+19,Min_Run_Range))
        {
         for(int i=_sp20; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+19,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+19,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate12=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=MathMax(Min_Leg_Range+19,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+18],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+18],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }

      if(_sp21>Min_Leg_Range+20+MathMax(Min_Leg_Range+20,Min_Run_Range))
        {
         for(int i=_sp21; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Min_Leg_Range+20,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW,Min_Leg_Range+20,i)];

            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
              {
               StartPointDate13=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
              }

            if(valid && bc>=MathMax(Min_Leg_Range+20,Min_Run_Range))
              {
               double midrange = NormalizeDouble((outH+outL)/2,Digits);
               
               if(LTBH > outH && LTBL < outL) break;
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+19],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  trade_box_no++;
                  
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Min_Leg_Range+19],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,BoxColor);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"B",Time[i],midrange,Time[1],outL,BoxColor);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
           }
        }        
     }

   return(rates_total);
  }
  
//+----------------------------------------+
//  Draw box                               |
//+----------------------------------------+
void drawBox(string name,datetime time1,double price1,datetime time2,double price2,color clr,bool background=false)
//+----------------------------------------+
  {
   ObjectCreate(name,OBJ_RECTANGLE,0,time1,price1,time2,price2);
   ObjectSet(name,OBJPROP_COLOR,clr);
   ObjectSet(name,OBJPROP_WIDTH,2);
   ObjectSet(name,OBJPROP_BACK,0);
  }
//+----------------------------------------+
//  Delete and Draw box                    |
//+----------------------------------------+
void deleteanddrawbox(string name,datetime time1,double price1,datetime time2,double price2,color clr,bool background=false)
//+----------------------------------------+
  {
   ObjectDelete(name);
   ObjectCreate(name,OBJ_RECTANGLE,0,time1,price1,time2,price2);
   ObjectSet(name,OBJPROP_COLOR,clr);
   ObjectSet(name,OBJPROP_WIDTH,2);
   ObjectSet(name,OBJPROP_BACK,0);
  }
//+------------------------------------------------------------------+
